Issue 90083 - Cannot use "Cmd+~" (aka "Cmd+`") to switch between different windows of the same application
Summary: Cannot use "Cmd+~" (aka "Cmd+`") to switch between different windows of the s...
Status: CLOSED FIXED
Alias: None
Product: porting
Classification: Code
Component: MacOSX (show other issues)
Version: OOo 3.0 RC3
Hardware: Mac Mac OS X, all
: P2 Trivial with 17 votes (vote)
Target Milestone: OOo 3.2
Assignee: h.ilter
QA Contact: issues@porting
URL:
Keywords: aqua
: 89420 92772 92997 94907 95540 115756 (view as issue list)
Depends on:
Blocks: 99080
  Show dependency tree
 
Reported: 2008-05-28 21:43 UTC by alexismp
Modified: 2010-11-24 04:38 UTC (History)
6 users (show)

See Also:
Issue Type: DEFECT
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments

Note You need to log in before you can comment on or make changes to this issue.
Description alexismp 2008-05-28 21:43:10 UTC
Standard behavior on Mac is to be able to swap between different windows of the same application using 
the command (apple) key + ~. This does not work for OOo3.0beta.

Sounds similar to issue 66125
(http://www.openoffice.org/issues/show_bug.cgi?id=66125)
Comment 1 eric.bachard 2008-05-29 07:36:02 UTC
All the documents I have read explain that the official way to navigate between several windows of the 
same applications are  CMD +  < or CMD + > , but not what you say.

Issue Invalid
Comment 2 florian 2008-05-29 07:42:00 UTC
I am not sure if this is really invalid since the default combination, whatever it may be (probably 
depending on language and keyboard settings), does not work in OOo3.0BETA.
Comment 3 eric.bachard 2008-05-29 09:36:25 UTC
@fheckl 

then I suggest to create a new issue, as enhancement 
Comment 4 alexismp 2008-05-29 09:49:12 UTC
Please see this: 
http://developer.apple.com/documentation/UserExperience/Conceptual/OSXHIGuidelines/XHIGKeyboardS
hortcuts/chapter_950_section_1.html#//apple_ref/doc/uid/TP40002725-CHDIGFBH
and look for "Activate the next open window in the frontmost application."
(It may be known also as CMD-`).
This is with a US keyboard layout. Most non-US keyboard users can't use (and even don't know about) this 
shortcut.

Reopening.
Comment 5 alexismp 2008-05-29 09:50:01 UTC
adjusting summary to reflect alternate keystroke name
Comment 6 alexismp 2008-06-02 22:16:57 UTC
Rising to P2.
Fidelity to Apple guidelines is what Mac OS users expect.
Comment 7 shaunmcdonald131 2008-06-02 22:31:34 UTC
I can confirm this on a UK keyboard. I too find it annoying that this shortcut doesn't work. It is the 
command+button to the left of z on an English keyboard.
Comment 8 philipp.lohmann 2008-07-10 11:01:51 UTC
At least Cmd-< and Cmd-> to switch between windows seem to work fine in
DEV300m23. These are configured in the system preferences per default as I use a
german keyboard. So I guess the other shortcuts should work, too. If somebody
can verify that this issue can be closed.
Comment 9 alexismp 2008-07-10 11:38:12 UTC
"Cmd+`" works for me. Thanks!
Comment 10 philipp.lohmann 2008-07-10 11:57:42 UTC
*** Issue 89420 has been marked as a duplicate of this issue. ***
Comment 11 msicotte 2008-07-11 02:31:39 UTC
Interesting ...

Test 1:
Open 2 Writer windows - Cmd + ` shifts between them
Also - Cmd + ~ shifts between them

Test 2:  
Now open a Calc Window - Cmd + ~ shifts between all three
Cmd + ` does nothing

Test 3:
Now close the Calc window - Results as in Test 1

Interesting - but not very user friendly

My observation is that on Mac OS X the standard behavior is:
Cmd + ~ cycles in the positive direction 1 -> 2 -> 3
Cmd + ` cycles in the negative direction 1 -> 3 -> 2

Platform:  Intel - Leopard
Other observations would be interesting.
Comment 12 alexismp 2008-07-11 06:51:14 UTC
Hum... I spoke too fast indeed.
I had only tried between Writer windows and observed correct Cmd + ~ and Cmd + ` cycling.
Now with one Writer window open and two Impress windows:
- I can cycle from Writer to one of the Impress windows, but then the key stroke becomes inoperative.
- When one of the Impress window owns the focus, the key stroke doesn't work either

Somehow this seems to be implemented for Writer only.
It ain't fixed just yet.

Comment 13 Raphael Bircher 2008-07-30 18:45:16 UTC
add keyword aqua

set myself to cc
Comment 14 alexismp 2008-10-08 09:45:55 UTC
Build 9350. Still not fixed for Impress windows. Seems to work for Writer windows, but once a Impress 
windows get the focus, the user can't continue to switch to other windows.
Comment 15 philipp.lohmann 2008-10-08 17:22:36 UTC
*** Issue 92997 has been marked as a duplicate of this issue. ***
Comment 16 philipp.lohmann 2008-10-08 17:23:50 UTC
seems to happen whenever there are child windows open, e.g. undocked toolbars or
dialogs
Comment 17 philipp.lohmann 2008-10-28 13:54:52 UTC
*** Issue 95540 has been marked as a duplicate of this issue. ***
Comment 18 jean.christophe.helary 2008-10-28 14:02:39 UTC
I confirm pl's last comment: in 3.0 stable the "Activate the next open window in the frontmost application" 
shortcut works unless a document has  undocked toolbars or dialogs, in which case the shortcut will 
navigate between the document and its dependent undocked toolbars or dialogs, but it won't go to the 
other opened documents.
Comment 19 philipp.lohmann 2008-10-29 10:53:57 UTC
*** Issue 94907 has been marked as a duplicate of this issue. ***
Comment 20 kmorris99 2008-11-14 00:06:34 UTC
CMD+` is bound to ".uno:ToggleFormula" .  Unfortunately CMD+` is not available to bind or rebind in 
the customize dialog.

I did some more digging and found that the file "current.xml", buried deep in the depths of the 
staroffice preferences (Library/Application 
Support/StarOffice/9/user/config/soffice.cfg/modules/scalc/accelerator/en-US/current.xml), contains 
the line:

 <accel:item accel:code="KEY_QUOTELEFT" xlink:href=".uno:ToggleFormula" accel:mod1="true"/>

Of course, the same line is in the file for both NeoOffice and OpenOffice/StarOffice, so in NeoOffice the 
app is consuming the keystroke before it gets to the shortcut key interpreter.  OpenOffice just passes it 
through.

I deleted the line above, and now I can use CMD+` to swap between documents when one of them is a 
calc spreadsheet.

It still doesn't help if you have undocked windows - no idea why that doesn't work.
Comment 21 jim0203 2008-11-14 00:46:16 UTC
@kmorris99: that works great, thanks! Note to all users of OOo 3: the path in
Library is a little different, but it is there.

Hopefully this will get fixed soon, though; I don't see it being that difficult
to fix, and it's a really amateur bug.
Comment 22 jean.christophe.helary 2008-11-14 06:08:03 UTC
The problem is not to not being able to assign an arbitrary shortcut, but the fact that when a non-docked 
item is involved the assigned shortcut will not work as expected.
Comment 23 kmorris99 2008-11-14 11:51:34 UTC
Agreed.  There are actually two issues here:

CMD+` doesn't work if there are non-docked toolbars; and

CMD+` doesn't work from calc (out of the box).

I don't want to assign an arbitrary shortcut.  As a Mac user, I hope to see CMD+` cycle between 
documents whether they be calc, or impress, or writer (etc).  I also expect it to work when there are non-
docked toolbars.  Apart from issues with shortcuts, I'm about ready to move off NeoOffice.
Comment 24 jean.christophe.helary 2008-11-14 12:07:47 UTC
@kmorris99

Mac users have the possibility to assign any shortcut to "Activate the next open window in the 
frontmost application." This happens in System Preferences > Keyboard & Mouse > Keyboard Shortcuts.

The ideal shortcut will depend on the keyboard physical and logical layout. I personally use Cmd+Esc 
because it is similar to Cmd+Tab and is easier on my fingers. Cmd+` requires pressing a Shift key and 
uses my two hands. An my keyboard is a standard Apple Japanese aluminum full keyboard. Nothing 
exotic.

To make a summary: the keyboard assigned to  "Activate the next open window in the frontmost 
application." does not work as expected in OOo3.0. The summary for this bug should be modified 
accordingly.
Comment 25 philipp.lohmann 2008-11-21 10:51:23 UTC
should be fixed in CWS vcl97
Comment 26 philipp.lohmann 2008-12-11 18:20:03 UTC
reopen, there is something broken again, need to fix in the next CWS
Comment 27 philipp.lohmann 2008-12-11 18:23:25 UTC
target 3.1 stays of course
Comment 28 philipp.lohmann 2008-12-11 18:35:11 UTC
note: probably interferes with the fix for issue 94443
Comment 29 philipp.lohmann 2009-01-20 14:43:40 UTC
The problem goes deeper after all. I have yet to find a way how to influence the
way the window cycling with Cmd-< > (or Cmd-' depending on your keyboard and
locale) works. There does not seem to be a way to hint to Cocoa which window the
focus should go to, it cycles simply throug all of them. The matter gets
complicated by the fact that switching the focus causes OOo to hide and show
some of its windows (like e.g. the navigator and stylist as well as torn off
toolbars). This seems to confuse matters considerably; at least if I do not hide
those the focus lands in one of OOo's windows (panel or document) after pressing
the move focus key.

Cycle backward however seems to hit a barrier at the first window which loses
the focus and gains it again. At the moment I know no 100% fix, but we can
improve behavior at least by 1. switching our dialogs and panel like objects to
NSPanel (which has the added benefit of making utility windows like navigator
and stylist more look like they should namely with smaller decorations) and 2.
not hiding the panels by hand on the mac.
Comment 30 philipp.lohmann 2009-01-20 16:05:59 UTC
further investigation yields, that not hiding the floating windows like the
navigator and stylist is not an option after all, since Cocoa will only hide
them itself when the application gets inactive, not when the parent window loses
main. That lets us end up with all the floaters for all documents visible at the
same time, which is even less desirable than the switching problem.

That throws us back to square one; unless someone finds a solution to tell cocoa
which windows actually should be in the cycle, there is not much we can do.
Handling the key press Cmd-< ourselves is not an option since it is configurable
in the preferences; we'd need to find out the configuration then (does somebody
know how ?).

In light of the code freeze nearing, I'll have to move the target (in the hopes
some fresh ideas come up), sorry.
Comment 31 eric.bachard 2009-02-10 18:26:40 UTC
Adding this issue to the meta list
Comment 32 Raphael Bircher 2009-07-14 08:27:00 UTC
*** Issue 92772 has been marked as a duplicate of this issue. ***
Comment 33 philipp.lohmann 2009-09-03 20:03:34 UTC
"Fixed" in CWS vcl105.

I did not find a really good solution but to handle the window cycling
ourselves. However for a real fix we'd need to find out which actual system key
combination cycles forward or backward. Alas I have not found an API to get that
information, so currently this is hardcoded to both Cmd-</Cmd-> and Cmd-~/Cmd-`.
Comment 34 philipp.lohmann 2009-09-07 12:33:22 UTC
please verify in CWS vcl105
Comment 35 h.ilter 2009-09-10 14:55:55 UTC
Verified with cws vcl105 = OK
Comment 36 jnoreiko 2009-11-04 11:00:23 UTC
Fixed in the word processor, but an issue remains in the spreadsheet: see
http://www.openoffice.org/issues/show_bug.cgi?id=106598
Comment 37 Raphael Bircher 2010-01-15 08:04:37 UTC
Tested on a MacBook with 10.5.x and OOO320_m9

Works fine
Closing Issue
Comment 38 eric.savary 2010-11-24 04:38:46 UTC
*** Issue 115756 has been marked as a duplicate of this issue. ***